if not ModCore then
	log("[ERROR] Unable to find ModCore from BeardLib! Is BeardLib installed correctly?")
	return
end

colorTextCore = colorTextCore or class(ModCore)

function colorTextCore:init()
	--Calling the base function for init from ModCore
	--self_tbl, config path, auto load modules, auto post init modules
	self.super.init(self, ModPath .. "config.xml", true, true)
end

if not _G.colorText then
	local success, err = pcall(function() colorTextCore:new() end)
	if not success then
		log("[ERROR] An error occured on the initialization of Color Text. " .. tostring(err))
	end
end

if colorText == nil then
    _G.colorText = {}
end

function colorText:colorDecode(colorEncoded)
    local rgb = {}
    for i = 1, #colorEncoded do
        local c = colorEncoded:sub(i,i)
        if c == "," then
            rgb[table.getn(rgb)+1] = i
        end
    end
    local r = tonumber(string.sub(colorEncoded, rgb[1]+2, rgb[2]-1))*255
    local g = tonumber(string.sub(colorEncoded, rgb[2]+2, rgb[3]-1))*255
    local b = tonumber(string.sub(colorEncoded, rgb[3]+2, string.len(colorEncoded)-1))*255
    rgb={r,g,b}
    local hexadecimal = ''

	for key, value in pairs(rgb) do
		local hex = ''

		while(value > 0)do
			local index = math.fmod(value, 16) + 1
			value = math.floor(value / 16)
			hex = string.sub('0123456789ABCDEF', index, index) .. hex			
		end

		if(string.len(hex) == 0)then
			hex = '00'

		elseif(string.len(hex) == 1)then
			hex = '0' .. hex
		end

		hexadecimal = hexadecimal .. hex
	end

	return hexadecimal
end

-- function colorText:colorEncode(colorDecoded)
-- 	-- return colorDecoded
--     return "Color(1, " .. tostring(tonumber("0x"..colorDecoded:sub(1,2))/255) .. ", " .. tostring(tonumber("0x"..colorDecoded:sub(3,4))/255) .. tostring(tonumber("0x"..colorDecoded:sub(5,6))/255) .. ")"
-- end

function colorText:Init()
    colorText._path = ModPath
    colorText._data_path = SavePath .. "colorText.json"
    colorText.data = {
        hotlineMiami = {
            colorText_chat_color_1                    = "66ff99",
            colorText_chat_color_2                    = "66ffff",
            colorText_chat_color_3                    = "ff6666",
            colorText_chat_color_4                    = "ffcc66",
            colorText_chat_color_5                    = "33CCFF",
            colorText_overlay_effects_spectator_color = "66ffff",
            colorText_preplanning_peer_colors_1       = "66ff99",
            colorText_preplanning_peer_colors_2       = "66ffff",
            colorText_preplanning_peer_colors_3       = "ff6666",
            colorText_preplanning_peer_colors_4       = "ffcc66",
            colorText_screen_color_button_stage_2     = "66ffff",
            colorText_screen_color_button_stage_3     = "ff80df",
            colorText_screen_color_community_color    = "66ffff",
            colorText_screen_color_crime_spree_risk   = "ffcc66",
            colorText_screen_color_crimenet_lines     = "ff80df",
            colorText_screen_color_dlc_color          = "ffcc66",
            colorText_screen_color_important_1        = "ff6666",
            colorText_screen_color_item_stage_3       = "ff80df",
            colorText_screen_color_resource           = "00ff0d",
            colorText_screen_color_risk               = "ffcc66",
            colorText_screen_color_skirmish_color     = "ff6666",
            colorText_screen_color_text               = "66ff99",
            colorText_screen_color_title              = "ff80df",
            colorText_system_chat_color               = "ff80df",
        }, redGrey = {
            colorText_chat_color_1                    = "51d200",
            colorText_chat_color_2                    = "0568e1",
            colorText_chat_color_3                    = "c30000",
            colorText_chat_color_4                    = "d2cb00",
            colorText_chat_color_5                    = "33CCFF",
            colorText_overlay_effects_spectator_color = "FF00FF",
            colorText_preplanning_peer_colors_1       = "51d200",
            colorText_preplanning_peer_colors_2       = "0568e1",
            colorText_preplanning_peer_colors_3       = "c30000",
            colorText_preplanning_peer_colors_4       = "d2cb00",
            colorText_screen_color_button_stage_2     = "4d4d4d",
            colorText_screen_color_button_stage_3     = "ff0000",
            colorText_screen_color_community_color    = "eb00ff",
            colorText_screen_color_crime_spree_risk   = "f900ff",
            colorText_screen_color_crimenet_lines     = "ff0000",
            colorText_screen_color_dlc_color          = "ff0000",
            colorText_screen_color_important_1        = "ff6666",
            colorText_screen_color_item_stage_3       = "FF0000",
            colorText_screen_color_resource           = "b50000",
            colorText_screen_color_risk               = "ff0000",
            colorText_screen_color_skirmish_color     = "2aff00",
            colorText_screen_color_text               = "ff6666",
            colorText_screen_color_title              = "ff0000",
            colorText_system_chat_color               = "ff0000",
        }, blueWhite = {
            colorText_chat_color_1                    = "51d200",
            colorText_chat_color_2                    = "0568e1",
            colorText_chat_color_3                    = "c30000",
            colorText_chat_color_4                    = "d2cb00",
            colorText_chat_color_5                    = "33CCFF",
            colorText_overlay_effects_spectator_color = "FF00FF",
            colorText_preplanning_peer_colors_1       = "51d200",
            colorText_preplanning_peer_colors_2       = "0568e1",
            colorText_preplanning_peer_colors_3       = "c30000",
            colorText_preplanning_peer_colors_4       = "d2cb00",
            colorText_screen_color_button_stage_2     = "0000ff",
            colorText_screen_color_button_stage_3     = "e6e6e6",
            colorText_screen_color_community_color    = "eb00ff",
            colorText_screen_color_crime_spree_risk   = "f900ff",
            colorText_screen_color_crimenet_lines     = "0000ff",
            colorText_screen_color_dlc_color          = "ff0000",
            colorText_screen_color_important_1        = "ff6666",
            colorText_screen_color_item_stage_3       = "FF0000",
            colorText_screen_color_resource           = "ff00ff",
            colorText_screen_color_risk               = "0000ff",
            colorText_screen_color_skirmish_color     = "2aff00",
            colorText_screen_color_text               = "6666ff",
            colorText_screen_color_title              = "0000ff",
            colorText_system_chat_color               = "ff0000",
        }, orange={
            colorText_chat_color_1                    = "66ff99",
            colorText_chat_color_2                    = "66ffff",
            colorText_chat_color_3                    = "ff6666",
            colorText_chat_color_4                    = "ffcc66",
            colorText_chat_color_5                    = "33CCFF",
            colorText_overlay_effects_spectator_color = "FF00FF",
            colorText_preplanning_peer_colors_1       = "66ff99",
            colorText_preplanning_peer_colors_2       = "66ffff",
            colorText_preplanning_peer_colors_3       = "ff6666",
            colorText_preplanning_peer_colors_4       = "ffcc66",
            colorText_screen_color_button_stage_2     = "FF4500",
            colorText_screen_color_button_stage_3     = "FFEFD5",
            colorText_screen_color_community_color    = "FFD700",
            colorText_screen_color_crime_spree_risk   = "FF00FF",
            colorText_screen_color_crimenet_lines     = "FF4500",
            colorText_screen_color_dlc_color          = "FFFF00",
            colorText_screen_color_important_1        = "ff6666",
            colorText_screen_color_item_stage_3       = "FF0000",
            colorText_screen_color_resource           = "ADFF2F",
            colorText_screen_color_risk               = "7FFF00",
            colorText_screen_color_skirmish_color     = "8B008B",
            colorText_screen_color_text               = "FF8C00",
            colorText_screen_color_title              = "E6E6FA",
            colorText_system_chat_color               = "ff80df",
        }, aquaFuchsia={
            colorText_chat_color_1                    = "66ff99",
            colorText_chat_color_2                    = "66ffff",
            colorText_chat_color_3                    = "ff6666",
            colorText_chat_color_4                    = "ffcc66",
            colorText_chat_color_5                    = "33CCFF",
            colorText_overlay_effects_spectator_color = "FF00FF",
            colorText_preplanning_peer_colors_1       = "66ff99",
            colorText_preplanning_peer_colors_2       = "66ffff",
            colorText_preplanning_peer_colors_3       = "ff6666",
            colorText_preplanning_peer_colors_4       = "ffcc66",
            colorText_screen_color_button_stage_2     = "FF00FF",
            colorText_screen_color_button_stage_3     = "00FFFF",
            colorText_screen_color_community_color    = "FF00FF",
            colorText_screen_color_crime_spree_risk   = "00FFFF",
            colorText_screen_color_crimenet_lines     = "00FFFF",
            colorText_screen_color_dlc_color          = "00FFFF",
            colorText_screen_color_important_1        = "ff6666",
            colorText_screen_color_item_stage_3       = "FF00FF",
            colorText_screen_color_resource           = "00FFFF",
            colorText_screen_color_risk               = "00FFFF",
            colorText_screen_color_skirmish_color     = "FF00FF",
            colorText_screen_color_text               = "FF00FF",
            colorText_screen_color_title              = "00FFFF",
            colorText_system_chat_color               = "ff80df",
        }, greenWhite={
            colorText_chat_color_1                    = "66ff99",
            colorText_chat_color_2                    = "66ffff",
            colorText_chat_color_3                    = "ff6666",
            colorText_chat_color_4                    = "ffcc66",
            colorText_chat_color_5                    = "33CCFF",
            colorText_overlay_effects_spectator_color = "FF00FF",
            colorText_preplanning_peer_colors_1       = "66ff99",
            colorText_preplanning_peer_colors_2       = "66ffff",
            colorText_preplanning_peer_colors_3       = "ff6666",
            colorText_preplanning_peer_colors_4       = "ffcc66",
            colorText_screen_color_button_stage_2     = "00FF00",
            colorText_screen_color_button_stage_3     = "98FB98",
            colorText_screen_color_community_color    = "00FF00",
            colorText_screen_color_crime_spree_risk   = "00FF00",
            colorText_screen_color_crimenet_lines     = "00FF00",
            colorText_screen_color_dlc_color          = "FFFF00",
            colorText_screen_color_important_1        = "ff6666",
            colorText_screen_color_item_stage_3       = "FF0000",
            colorText_screen_color_resource           = "ADFF2F",
            colorText_screen_color_risk               = "FF0000",
            colorText_screen_color_skirmish_color     = "8B008B",
            colorText_screen_color_text               = "FFEFD5",
            colorText_screen_color_title              = "E6E6FA",
            colorText_system_chat_color               = "ff80df",
        }, default = {
            colorText_screen_color_community_color    = colorText:colorDecode("Color(1, 0.23137299716473, 0.68235301971436, 0.99607801437378)"),
            colorText_chat_color_2                    = colorText:colorDecode("Color(1, 0.4666660130024, 0.71372497081757, 0.80000001192093)"),
            colorText_preplanning_peer_colors_1       = colorText:colorDecode("Color(1, 0.50980299711227, 0.60000002384186, 0.11372499912977)"),
            colorText_system_chat_color               = colorText:colorDecode("Color(1, 1, 0.83137202262878, 0)"),
            colorText_chat_color_5                    = colorText:colorDecode("Color(1, 0.20000000298023, 0.80000001192093, 1)"),
            colorText_screen_color_important_1        = colorText:colorDecode("Color(1, 1, 0.20000000298023, 0.20000000298023)"),
            colorText_chat_color_1                    = colorText:colorDecode("Color(1, 0.75686198472977, 0.98431301116943, 0.59215599298477)"),
            colorText_overlay_effects_spectator_color = colorText:colorDecode("Color(1, 0, 0, 0)"),
            colorText_chat_color_4                    = colorText:colorDecode("Color(1, 0.80000001192093, 0.63137197494507, 0.40000000596046)"),
            colorText_screen_color_dlc_color          = colorText:colorDecode("Color(1, 1, 0.8313729763031, 0)"),
            colorText_preplanning_peer_colors_3       = colorText:colorDecode("Color(1, 1, 0.4666660130024, 0)"),
            colorText_screen_color_crimenet_lines     = colorText:colorDecode("Color(1, 0.49803900718689, 0.61568599939346, 0.71372598409653)"),
            colorText_screen_color_skirmish_color     = colorText:colorDecode("Color(1, 1, 0.33333298563957, 0.11764699965715)"),
            colorText_screen_color_risk               = colorText:colorDecode("Color(1, 1, 0.80000001192093, 0)"),
            colorText_screen_color_resource           = colorText:colorDecode("Color(1, 0.30196100473404, 0.7764710187912, 1)"),
            colorText_screen_color_item_stage_3       = colorText:colorDecode("Color(1, 0.09019610285759, 0.12941199541092, 0.14902000129223)"),
            colorText_preplanning_peer_colors_2       = colorText:colorDecode("Color(1, 0, 0.32941100001335, 1)"),
            colorText_screen_color_button_stage_3     = colorText:colorDecode("Color(0.49803900718689, 0, 0.66666698455811, 1)"),
            colorText_screen_color_button_stage_2     = colorText:colorDecode("Color(1, 0.30196100473404, 0.7764710187912, 1)"),
            colorText_screen_color_text               = colorText:colorDecode("Color(1, 1, 1, 1)"),
            colorText_preplanning_peer_colors_4       = colorText:colorDecode("Color(1, 1, 1, 0)"),
            colorText_screen_color_crime_spree_risk   = colorText:colorDecode("Color(1, 1, 1, 0)"),
            colorText_chat_color_3                    = colorText:colorDecode("Color(1, 0.69411700963974, 0.40392100811005, 0.3490189909935)"),
            colorText_screen_color_title              = colorText:colorDecode("Color(1, 1, 1, 1)"),
        }, custom = {}, currentColors = {}
    }
end
colorText:Init()

function colorText:Save()
    local file = io.open( self._data_path, "w+" )
    if file then
        file:write( json.encode( self._data ) )
        file:close()
    end
end

function colorText:Load()
    self:LoadDefaults()
    local file = io.open( self._data_path, "r" )
    if file then
        local data = json.decode( file:read("*all") )
        file:close()
        if data then
            for k, v in pairs(data) do
                if self._data[k] ~= nil then
                    self._data[k] = v
                end
            end
        end
    end
end

function colorText:LoadDefaults()
    self._data = {
        colorText_chat_color_1                    = "Color(1, 0.75686198472977, 0.98431301116943, 0.59215599298477)",
        colorText_chat_color_2                    = "Color(1, 0.4666660130024, 0.71372497081757, 0.80000001192093)",
        colorText_chat_color_3                    = "Color(1, 0.69411700963974, 0.40392100811005, 0.3490189909935)",
        colorText_chat_color_4                    = "Color(1, 0.80000001192093, 0.63137197494507, 0.40000000596046)",
        colorText_chat_color_5                    = "Color(1, 0.20000000298023, 0.80000001192093, 1)",
        colorText_overlay_effects_spectator_color = "Color(1, 0, 0, 0)",
        colorText_preplanning_peer_colors_1       = "Color(1, 0.50980299711227, 0.60000002384186, 0.11372499912977)",
        colorText_preplanning_peer_colors_2       = "Color(1, 0, 0.32941100001335, 1)",
        colorText_preplanning_peer_colors_3       = "Color(1, 1, 0.4666660130024, 0)",
        colorText_preplanning_peer_colors_4       = "Color(1, 1, 1, 0)",
        colorText_screen_color_button_stage_2     = "Color(1, 0.30196100473404, 0.7764710187912, 1)",
        colorText_screen_color_button_stage_3     = "Color(0.49803900718689, 0, 0.66666698455811, 1)",
        colorText_screen_color_community_color    = "Color(1, 0.23137299716473, 0.68235301971436, 0.99607801437378)",
        colorText_screen_color_crime_spree_risk   = "Color(1, 1, 1, 0)",
        colorText_screen_color_crimenet_lines     = "Color(1, 0.49803900718689, 0.61568599939346, 0.71372598409653)",
        colorText_screen_color_dlc_color          = "Color(1, 1, 0.8313729763031, 0)",
        colorText_screen_color_important_1        = "Color(1, 1, 0.20000000298023, 0.20000000298023)",
        colorText_screen_color_item_stage_3       = "Color(1, 0.09019610285759, 0.12941199541092, 0.14902000129223)",
        colorText_screen_color_resource           = "Color(1, 0.30196100473404, 0.7764710187912, 1)",
        colorText_screen_color_risk               = "Color(1, 1, 0.80000001192093, 0)",
        colorText_screen_color_skirmish_color     = "Color(1, 1, 0.33333298563957, 0.11764699965715)",
        colorText_screen_color_text               = "Color(1, 1, 1, 1)",
        colorText_screen_color_title              = "Color(1, 1, 1, 1)",
        colorText_system_chat_color               = "Color(1, 1, 0.83137202262878, 0)",
        colorType = 1,
    }
end
colorText:Load()
colorText:Save()

function colorText:copyColors()
	colorText:Load()
	local run = true
	local currentColors = {}
    if colorText._data.colorType == 1 then
        currentColors = colorText.data.hotlineMiami
    elseif colorText._data.colorType == 2 then
        currentColors = colorText.data.redGrey
    elseif colorText._data.colorType == 3 then
        currentColors = colorText.data.blueWhite
    elseif colorText._data.colorType == 4 then
        currentColors = colorText.data.orange
    elseif colorText._data.colorType == 5 then
        currentColors = colorText.data.aquaFuchsia
    elseif colorText._data.colorType == 6 then
        currentColors = colorText.data.greenWhite
    elseif colorText._data.colorType == 7 then
		currentColors = colorText.data.default
	else
		run = false
	end
	if run then
		colorText.colorType = colorText._data.colorType
        colorText._data = {
			colorText_chat_color_1                    = currentColors.colorText_chat_color_1,
			colorText_chat_color_2                    = currentColors.colorText_chat_color_2,
			colorText_chat_color_3                    = currentColors.colorText_chat_color_3,
			colorText_chat_color_4                    = currentColors.colorText_chat_color_4,
			colorText_chat_color_5                    = currentColors.colorText_chat_color_5,
			colorText_overlay_effects_spectator_color = currentColors.colorText_overlay_effects_spectator_color,
			colorText_screen_color_button_stage_2     = currentColors.colorText_screen_color_button_stage_2,
			colorText_screen_color_button_stage_3     = currentColors.colorText_screen_color_button_stage_3,
			colorText_screen_color_community_color    = currentColors.colorText_screen_color_community_color,
			colorText_screen_color_crime_spree_risk   = currentColors.colorText_screen_color_crime_spree_risk,
			colorText_screen_color_crimenet_lines     = currentColors.colorText_screen_color_crimenet_lines,
			colorText_screen_color_dlc_color          = currentColors.colorText_screen_color_dlc_color,
			colorText_screen_color_important_1        = currentColors.colorText_screen_color_important_1,
			colorText_screen_color_item_stage_3       = currentColors.colorText_screen_color_item_stage_3,
			colorText_screen_color_resource           = currentColors.colorText_screen_color_resource,
			colorText_screen_color_risk               = currentColors.colorText_screen_color_risk,
			colorText_screen_color_skirmish_color     = currentColors.colorText_screen_color_skirmish_color,
			colorText_screen_color_text               = currentColors.colorText_screen_color_text,
			colorText_screen_color_title              = currentColors.colorText_screen_color_title,
			colorText_system_chat_color               = currentColors.colorText_system_chat_color,
			colorText_preplanning_peer_colors_1       = currentColors.colorText_preplanning_peer_colors_1,
			colorText_preplanning_peer_colors_2       = currentColors.colorText_preplanning_peer_colors_2,
			colorText_preplanning_peer_colors_3       = currentColors.colorText_preplanning_peer_colors_3,
			colorText_preplanning_peer_colors_4       = currentColors.colorText_preplanning_peer_colors_4,
			colorType                                 = colorText.colorType,
        }
        colorText:Save()
        local colorTextModule=colortext:GetModule("Options")
        local colorText_chat_color_1                    = colorTextModule._menu_items["colorText_chat_color_1"]
        local colorText_chat_color_2                    = colorTextModule._menu_items["colorText_chat_color_2"]
        local colorText_chat_color_3                    = colorTextModule._menu_items["colorText_chat_color_3"]
        local colorText_chat_color_4                    = colorTextModule._menu_items["colorText_chat_color_4"]
        local colorText_chat_color_5                    = colorTextModule._menu_items["colorText_chat_color_5"]
        local colorText_overlay_effects_spectator_color = colorTextModule._menu_items["colorText_overlay_effects_spectator_color"]
        local colorText_screen_color_button_stage_2     = colorTextModule._menu_items["colorText_screen_color_button_stage_2"]
        local colorText_screen_color_button_stage_3     = colorTextModule._menu_items["colorText_screen_color_button_stage_3"]
        local colorText_screen_color_community_color    = colorTextModule._menu_items["colorText_screen_color_community_color"]
        local colorText_screen_color_crime_spree_risk   = colorTextModule._menu_items["colorText_screen_color_crime_spree_risk"]
        local colorText_screen_color_crimenet_lines     = colorTextModule._menu_items["colorText_screen_color_crimenet_lines"]
        local colorText_screen_color_dlc_color          = colorTextModule._menu_items["colorText_screen_color_dlc_color"]
        local colorText_screen_color_important_1        = colorTextModule._menu_items["colorText_screen_color_important_1"]
        local colorText_screen_color_item_stage_3       = colorTextModule._menu_items["colorText_screen_color_item_stage_3"]
        local colorText_screen_color_resource           = colorTextModule._menu_items["colorText_screen_color_resource"]
        local colorText_screen_color_risk               = colorTextModule._menu_items["colorText_screen_color_risk"]
        local colorText_screen_color_skirmish_color     = colorTextModule._menu_items["colorText_screen_color_skirmish_color"]
        local colorText_screen_color_text               = colorTextModule._menu_items["colorText_screen_color_text"]
        local colorText_screen_color_title              = colorTextModule._menu_items["colorText_screen_color_title"]
        local colorText_system_chat_color               = colorTextModule._menu_items["colorText_system_chat_color"]
        local colorText_preplanning_peer_colors_1       = colorTextModule._menu_items["colorText_preplanning_peer_colors_1"]
        local colorText_preplanning_peer_colors_2       = colorTextModule._menu_items["colorText_preplanning_peer_colors_2"]
        local colorText_preplanning_peer_colors_3       = colorTextModule._menu_items["colorText_preplanning_peer_colors_3"]
        local colorText_preplanning_peer_colors_4       = colorTextModule._menu_items["colorText_preplanning_peer_colors_4"]

        colorText_chat_color_1:set_value(currentColors.colorText_chat_color_1)
        colorText_chat_color_2:set_value(currentColors.colorText_chat_color_2)
        colorText_chat_color_3:set_value(currentColors.colorText_chat_color_3)
        colorText_chat_color_4:set_value(currentColors.colorText_chat_color_4)
        colorText_chat_color_5:set_value(currentColors.colorText_chat_color_5)
        colorText_overlay_effects_spectator_color:set_value(currentColors.colorText_overlay_effects_spectator_color)
        colorText_screen_color_button_stage_2:set_value(currentColors.colorText_screen_color_button_stage_2)
        colorText_screen_color_button_stage_3:set_value(currentColors.colorText_screen_color_button_stage_3)
        colorText_screen_color_community_color:set_value(currentColors.colorText_screen_color_community_color)
        colorText_screen_color_crime_spree_risk:set_value(currentColors.colorText_screen_color_crime_spree_risk)
        colorText_screen_color_crimenet_lines:set_value(currentColors.colorText_screen_color_crimenet_lines)
        colorText_screen_color_dlc_color:set_value(currentColors.colorText_screen_color_dlc_color)
        colorText_screen_color_important_1:set_value(currentColors.colorText_screen_color_important_1)
        colorText_screen_color_item_stage_3:set_value(currentColors.colorText_screen_color_item_stage_3)
        colorText_screen_color_resource:set_value(currentColors.colorText_screen_color_resource)
        colorText_screen_color_risk:set_value(currentColors.colorText_screen_color_risk)
        colorText_screen_color_skirmish_color:set_value(currentColors.colorText_screen_color_skirmish_color)
        colorText_screen_color_text:set_value(currentColors.colorText_screen_color_text)
        colorText_screen_color_title:set_value(currentColors.colorText_screen_color_title)
        colorText_system_chat_color:set_value(currentColors.colorText_system_chat_color)
        colorText_preplanning_peer_colors_1:set_value(currentColors.colorText_preplanning_peer_colors_1)
        colorText_preplanning_peer_colors_2:set_value(currentColors.colorText_preplanning_peer_colors_2)
        colorText_preplanning_peer_colors_3:set_value(currentColors.colorText_preplanning_peer_colors_3)
        colorText_preplanning_peer_colors_4:set_value(currentColors.colorText_preplanning_peer_colors_4)

        colorText_chat_color_1:trigger()
        colorText_chat_color_2:trigger()
        colorText_chat_color_3:trigger()
        colorText_chat_color_4:trigger()
        colorText_chat_color_5:trigger()
        colorText_overlay_effects_spectator_color:trigger()
        colorText_screen_color_button_stage_2:trigger()
        colorText_screen_color_button_stage_3:trigger()
        colorText_screen_color_community_color:trigger()
        colorText_screen_color_crime_spree_risk:trigger()
        colorText_screen_color_crimenet_lines:trigger()
        colorText_screen_color_dlc_color:trigger()
        colorText_screen_color_important_1:trigger()
        colorText_screen_color_item_stage_3:trigger()
        colorText_screen_color_resource:trigger()
        colorText_screen_color_risk:trigger()
        colorText_screen_color_skirmish_color:trigger()
        colorText_screen_color_text:trigger()
        colorText_screen_color_title:trigger()
        colorText_system_chat_color:trigger()
        colorText_preplanning_peer_colors_1:trigger()
        colorText_preplanning_peer_colors_2:trigger()
        colorText_preplanning_peer_colors_3:trigger()
        colorText_preplanning_peer_colors_4:trigger()

	end
end

function colorText:updateColors()
    tweak_data:colorText()
end